# Wallet

## Payin by Wallet

<mark style="color:green;">`POST`</mark> `https://gateway-test.pagsmile.com/trade/pay`

This endpoint allows you to submit a payin by Wallet in Europe.

#### Headers

| Name                                            | Type   | Description                                |
| ----------------------------------------------- | ------ | ------------------------------------------ |
| Content-Type<mark style="color:red;">\*</mark>  | string | application/json; chartset=UTF-8           |
| Authorization<mark style="color:red;">\*</mark> | string | Basic Base($app\_*id:$security\_*&#x6B;ey) |

#### Request Body

| Name                                              | Type   | Description                                                                                                                 |
| ------------------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------- |
| app\_id<mark style="color:red;">\*</mark>         | string | <p>created app's id at dashboard</p><p>- Max. 32 chars -</p>                                                                |
| method<mark style="color:red;">\*</mark>          | string | Fixed value: Wallet                                                                                                         |
| out\_trade\_no<mark style="color:red;">\*</mark>  | string | <p>ID given by the merchant in their system<br>- Max. 64 chars - </p>                                                       |
| notify\_url<mark style="color:red;">\*</mark>     | string | Where Pagsmile will send notification to                                                                                    |
| timestamp<mark style="color:red;">\*</mark>       | string | <p>yyyy-MM-dd HH:mm:ss<br>- Max. 19 chars -</p>                                                                             |
| subject<mark style="color:red;">\*</mark>         | string | <p>payment reason or item title</p><p>- Max. 128 chars -</p>                                                                |
| order\_amount<mark style="color:red;">\*</mark>   | string | <p>payment amount<br>- check <a href="https://docs.pagsmile.com/payin/data/payment-method#brazil">here</a> for limits -</p> |
| order\_currency<mark style="color:red;">\*</mark> | string | Fixed value: EUR                                                                                                            |
| content                                           | string | <p>payment reason detail or item detail</p><p>- Max. 255 chars -</p>                                                        |
| buyer\_id<mark style="color:red;">\*</mark>       | string | merchant user's id                                                                                                          |
| website\_url                                      | string | <p>merchant website URL</p><p>- Max. 128 chars -</p>                                                                        |
| return\_url                                       | string | Redirect to Merchant's url when user finished checkout                                                                      |
| channel<mark style="color:red;">\*</mark>         | string | <p>Wallet type<br>- WechatPay -</p>                                                                                         |
| user\_ip<mark style="color:red;">\*</mark>        | string | User's ip                                                                                                                   |
| device.type<mark style="color:red;">\*</mark>     | string | <p>User's device type</p><p>- wap or web -                                                                                  |

</p>                                                                             |

{% tabs %}
{% tab title="200 submit successfully" %}
{% tabs %}
{% tab title="WechatPay" %}

```
{
    "code": "10000",
    "msg": "Success",
    "prepay_id": "dHlIWXVo****-8535494B",
    "trade_no": "20240*****21",
    "out_trade_no": "out_tr*****300",
    "pay_url":"https://wx.tenpay.com/cgi-bin/mmpayweb-bin/checkmweb?prepay_id=wx21162254055845c9733cf104b69c3a0000&package=3820227936&redirect_url=https%3A%2F%2Fwww.metacene.io%2F", //Return when device.type=wap
    "trade_status": "PROCESSING",
    "wallet_url":"https://wx.tenpay.com/cgi-bin/mmpayweb-bin/checkmweb?prepay_id=wx21162254055845c9733cf104b69c3a0000&package=3820227936&redirect_url=https%3A%2F%2Fwww.metacene.io%2F", //Return when device.type=wap
    "qr_code": "weixin://wxpay/bizpayurl?pr=eBZYNHaz3" //Return when device.type=web
}
```

{% endtab %}
{% endtabs %}
{% endtab %}

{% tab title="400 duplicate out\_trade\_no" %}

```
{
    "code": "40002",
    "msg": "Business Failed",
    "sub_code": "duplicate-out_trade_no",
    "sub_msg": "out_trade_no is duplicate"
}
```

{% endtab %}
{% endtabs %}

## Example

```
curl --location --request POST 'https://gateway-test.pagsmile.com/trade/pay' \
--header 'Authorization: Basic MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==' \
--header 'Content-Type: application/json' \
--data-raw '{
    * "app_id": "162************38",
    * "out_trade_no": "202201010354006",
    * "method": "Wallet",
    * "channel": "WechatPay",
    * "order_amount": "300",
    * "order_currency": "EUR",
    * "subject": "trade pay test",
    * "content": "trade pay test conent",
    * "notify_url": "http://merchant/callback/success",
      "return_url": "https://www.merchant.com",
    * "buyer_id": "buyer_0101_0001",
    * "timestamp": "2022-01-01 03:54:01",
    * "user_ip":"127.0.0.1",
    * "device": { 
    *     "type": "wap" //wap or web.
      }
    }'
```

{% hint style="info" %}
Note:  **162\*\*\*\*\*\*\*\*\*\*\*\*38** is pagsmile's test app id for sandbox, and **MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==** is authorization token associated with the test app id.&#x20;
{% endhint %}

{% hint style="danger" %}
Please use your own **app\_id** and generate your own **authorization token** when testing.
{% endhint %}
